package ru.dbotthepony.kstarbound.defs.particle

import ru.dbotthepony.kommons.math.RGBAColor
import ru.dbotthepony.kommons.vector.Vector2d
import ru.dbotthepony.kommons.vector.Vector4d
import ru.dbotthepony.kstarbound.defs.AssetReference
import ru.dbotthepony.kstarbound.defs.animation.AnimationDefinition
import ru.dbotthepony.kstarbound.defs.animation.DestructionAction
import ru.dbotthepony.kstarbound.defs.image.SpriteReference
import ru.dbotthepony.kstarbound.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.util.SBPattern

@JsonFactory
data class ParticleConfig(
	val type: ParticleType,
	val animation: AssetReference<AnimationDefinition>? = null,
	val image: SpriteReference? = null,
	override val offset: Vector2d? = null,
	override val position: Vector2d? = null,
	override val offsetRegion: Vector4d? = null,
	override val initialVelocity: Vector2d? = null,
	override val finalVelocity: Vector2d? = null,
	override val approach: Vector2d? = null,
	override val angularVelocity: Double? = null,
	override val destructionAction: DestructionAction? = null,
	override val destructionTime: Double? = null,
	override val fade: Double? = null,
	override val size: Double? = null,
	override val layer: ParticleLayer? = null,
	override val timeToLive: Double? = null,
	override val variance: IParticleVariance? = null,
	override val color: RGBAColor? = null,
	override val text: SBPattern? = null,
) : IParticleConfig
