package ru.dbotthepony.kstarbound.world.entities

import ru.dbotthepony.kommons.core.Either
import ru.dbotthepony.kommons.util.AABB
import ru.dbotthepony.kommons.vector.Vector2d
import ru.dbotthepony.kstarbound.defs.item.api.IItemDefinition
import ru.dbotthepony.kstarbound.world.World
import ru.dbotthepony.kstarbound.world.physics.Poly

class ItemEntity(world: World<*, *>, val def: IItemDefinition) : Entity(world) {
	override val movement = EntityMovementController(this)

	init {
		movement.movementParameters = movement.movementParameters.copy(collisionPoly = Either.left(Poly(AABB.rectangle(Vector2d.ZERO, 0.75, 0.75))))
	}
}
